#include "profile-testee.h"
unsigned int prof_BsP(struct s_bit *s) {
    (*s).a=1;
    return (*s).a;
}

/* test a case with bitfields, no side effects, and no INDIRCT operator. */
unsigned int prof_Bsp(void) {
    unsigned int r0,r1;
    s_e.a=1;
    s_a[5].a=1;
    r0 = s_e.a;
    r1 = s_a[5].a;
    return r0+r1;
}

/* test a case with no bitfields and no side effects. */
unsigned int prof_bs(void) {
    unsigned int r0,r1;
    s_e.b=12;
    s_a[5].b=23;
    r0 = s_e.b;
    r1 = s_a[5].b;
    return r0+r1;
}

/* test a case with no bitfields and side effects. */
unsigned int prof_bS(void) {
    unsigned int r1;
    unsigned int offset=5;
    s_a[offset++].b=23;
    offset--;
    r1 = s_a[offset++].b;
    offset--;
    return offset+r1;
}

/* test a case with bitfields and side effects */
unsigned int prof_BS(void) {
    unsigned int r1;
    unsigned int offset=5;
    s_a[offset++].a=1;
    offset--;
    r1 = s_a[offset++].a;
    offset--;
    return offset+r1;
}

/* test a nested struct */
unsigned int prof_nested (void) {
    unsigned int r0,r1,r2,r3;
    ss_v.s.a = 1;
    ss_v.s.b = 2;
    ss_a[5].s.a = 0;
    ss_a[5].s.b = 3;
    r0 = ss_v.s.a;
    r1 = ss_v.s.b;
    r2 = ss_a[5].s.a;
    r3 = ss_a[5].s.b;
    return r0+r1+r2+r3;
}

int prof_no_mem (void) {
    return
	(((struct s_bit){1,4}).b)
	+
	s_e_value().b;  // no memory references are made here, but an imlpementation could do memory references if they wanted.
}
